' GDIplus_PB.inc
'
' Compiler:                 PB/CC 5.04, PB/Win 9.04
' Based on code by:         Steven Murry, Chris Holbrook, Jose Roca, Don Schulligan et alt.
' Further Modifications:    Gert Voland
' Date:                     16 June 2010

'==================================================================================================
' GDI Plus includes for Loading images from file (e.g.  .bmp | .png | .jpg | .gif | .tif)
' to/from PB Bitmaps     SM  3 Feb 2010
' Code below based on Chris Holbrook PB Forums 3 Jan 2010, based on Jose Roca's work.
'
' You need to be able to find out about GDI plus, reference Jose Rocas site (link @ 2/2/2010)
' http://www.jose.it-berater.org/gdiplus/iframe/index.htm
' You also should have on hand a link to full type library from Jose Roca (link valid @ 2/2/2010)
' http://www.jose.it-berater.org/smfforum/index.php?board=344.0
'==================================================================================================
'
'--------------------------------------------------------------------------------------------------
%UnitPixel = 2                              ' Sets each unit to be one device pixel
'--------------------------------------------------------------------------------------------------
'
TYPE GdiplusStartupInput
   GdiplusVersion           AS DWORD        ' Must be 1
   DebugEventCallback       AS DWORD        ' Ignored on free builds
   SuppressBackgroundThread AS LONG         ' FALSE unless you're prepared to call
                                            ' the hook/unhook functions properly
   SuppressExternalCodecs   AS LONG         ' FALSE unless you want GDI+ only to use
                                            ' its internal image codecs.
END TYPE 'GdiplusStartupInput

'--------------------------------------------------------------------------------------------------
'
TYPE GdiplusStartupOutput
   NotificationHook         AS DWORD
   NotificationUnhook       AS DWORD
END TYPE 'GdiplusStartupOutput

'--------------------------------------------------------------------------------------------------
'
TYPE ImageCodecInfo
   ClassID                  AS GUID         ' CLSID. Codec identifier
   FormatID                 AS GUID         ' GUID. File format identifier
   CodecName                AS DWORD        ' WCHAR*. Pointer to a null-terminated string
                                            '  that contains the codec name
   DllName                  AS DWORD        ' WCHAR*. Pointer to a null-terminated string
                                            '  that contains the path name of the DLL in
                                            '  which the codec resides. If the codec is not
                                            '  a DLL, this pointer is NULL
   FormatDescription        AS DWORD        ' WCHAR*. Pointer to a null-terminated string
                                            '  that contains the name of the format used by the codec
   FilenameExtension        AS DWORD        ' WCHAR*. Pointer to a null-terminated string
                                            '  that contains all file-name extensions associated
                                            '  with the codec. The extensions are separated with semicolons.
   MimeType                 AS DWORD        ' WCHAR*. Pointer to a null-terminated string
                                            '  that contains the mime type of the codec
   Flags                    AS DWORD        ' Combination of flags from the ImageCodecFlags enumeration
   Version                  AS DWORD        ' Integer that indicates the version of the codec
   SigCount                 AS DWORD        ' Integer that indicates the number of signatures
                                            '  used by the file format associated with the codec
   SigSize                  AS DWORD        ' Integer that indicates the number of bytes of each signature
   SigPattern               AS DWORD        ' BYTE*. Pointer to an array of bytes that contains
                                            '  the pattern for each signature
   SigMask                  AS DWORD        ' BYTE*. Pointer to an array of bytes that contains
                                            '  the mask for each signature
END TYPE 'ImageCodecInfo

'--------------------------------------------------------------------------------------------------

DECLARE FUNCTION GdiplusStartup             LIB "GDIPLUS.DLL" ALIAS "GdiplusStartup" _
            (token AS DWORD, inputbuf AS GdiplusStartupInput, outputbuf AS GdiplusStartupOutput) AS LONG
DECLARE SUB GdiplusShutdown                 LIB "GDIPLUS.DLL" ALIAS "GdiplusShutdown" _
            (BYVAL token AS DWORD)
DECLARE FUNCTION GdipGetImageEncodersSize   LIB "GDIPLUS.DLL" ALIAS "GdipGetImageEncodersSize" _
            (numEncoders AS DWORD, nSize AS DWORD) AS LONG
DECLARE FUNCTION GdipGetImageEncoders       LIB "GDIPLUS.DLL" ALIAS "GdipGetImageEncoders" _
            (BYVAL numEncoders AS DWORD, BYVAL nSize AS DWORD, BYVAL lpEncoders AS DWORD) AS LONG
DECLARE FUNCTION GdipSaveImageToFile        LIB "GDIPLUS.DLL" ALIAS "GdipSaveImageToFile" _
            (BYVAL lpImage AS DWORD, BYVAL flname AS DWORD, BYREF clsidEncoder AS GUID, _
             BYREF EncoderParams AS DWORD) AS LONG
DECLARE FUNCTION GdipLoadImageFromFile      LIB "GDIPLUS.DLL" ALIAS "GdipLoadImageFromFile" _
            (BYVAL flnameptr AS DWORD, lpImage AS DWORD) AS LONG
            '1st parm of GdipLoadImageFromFile is byval string in Patrice's translation and byval dword in
            ' Jose Roca's translation "for consistency with 1000s of functions..." per PBforums 19/11/09
DECLARE FUNCTION GdipGetImageDimension      LIB "GDIPLUS.DLL" ALIAS "GdipGetImageDimension" _
            (BYVAL nImage AS LONG, nWidth AS SINGLE, Height AS SINGLE) AS LONG
DECLARE FUNCTION GdipCreateFromHDC LIB "GDIPLUS.DLL" ALIAS "GdipCreateFromHDC" _
            (BYVAL hdc AS LONG, graphics AS LONG) AS LONG
DECLARE FUNCTION GdipCreateBitmapFromGdiDib LIB "GDIPLUS.DLL" ALIAS "GdipCreateBitmapFromGdiDib" _
            (BYREF BitMapInfo, BYVAL DWORD, BYREF DWORD) AS LONG
DECLARE FUNCTION GdipDisposeImage           LIB "GDIPLUS.DLL" ALIAS "GdipDisposeImage" _
            (BYVAL lpImage AS DWORD) AS LONG
DECLARE FUNCTION GdipDeleteGraphics         LIB "GDIPLUS.DLL" ALIAS "GdipDeleteGraphics" _
            (BYVAL Graphics AS LONG) AS LONG
DECLARE FUNCTION GdipCreateBitmapFromStream LIB "GDIPLUS.DLL" ALIAS "GdipCreateBitmapFromStream" _
            (BYVAL pstream AS DWORD, m_pbitmap AS LONG) AS LONG
DECLARE FUNCTION CreateStreamOnHGlobal      LIB "OLE32.DLL"   ALIAS "CreateStreamOnHGlobal" _
            (BYVAL hglobal AS DWORD, BYVAL fdeleteonrelease AS DWORD, pstm AS DWORD) AS LONG
DECLARE FUNCTION GdipDrawImageRectI         LIB "GDIPLUS.DLL" ALIAS "GdipDrawImageRectI" _
            (BYVAL hgraphics AS DWORD, BYVAL nimage AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, _
            BYVAL nWidth AS LONG, BYVAL nWeight AS LONG) AS LONG

DECLARE FUNCTION pStreamRelease(punk AS DWORD) AS LONG

'========================================================================================
' The following functions needs GDIPlus - so your program needs XP or better, basically.
'
' You need to call GdiplusInit(token) before any load/save and GdiplusShutdown(token) to
' clean up. If you do not, Gdiplus calls will access memory they are not allowed - a GPF.
'========================================================================================

FUNCTION GdiPlusInit(token AS DWORD) AS LONG
' Initialize GDI+ - this is required ONCE in app if any GDI+ stuff is used

    LOCAL inputbuf      AS GdiplusStartupInput

    FUNCTION = %TRUE

    inputbuf.GdiplusVersion = 1                                 ' Must be = 1

    IF GdiplusStartup(token, inputbuf, BYVAL %Null) <> 0 THEN   ' Return = 0, when successful
        MessageBOX 0, "[GdiPlusInit]" + $CRLF + "GDI+ not initialized", "Error", 0
        FUNCTION = %FALSE
    END IF

END FUNCTION 'GDIPlusOpen

'--------------------------------------------------------------------------------------------------

FUNCTION GraphicLoadImageFileToBitmap (BYREF sImageFileName AS STRING) AS DWORD
' Returns PB bitmap handle of image.
' Supply the function with an ImageFileName - for instance photo.jpg - and it
' will attempt to make a new PB Graphic memory bitmap containing the image.
' sImageFileName can be name or path+name, extn determines file type:  .bmp | .png | .jpg | .gif | .tif

    LOCAL ucImageFileName   AS STRING       'sImageFileName converted to unicode
    LOCAL pImage            AS DWORD        'GDI+ image pointer, after reading in
    LOCAL ImgWidth          AS SINGLE       'Image width, pixels
    LOCAL ImgHeight         AS SINGLE       'Image height, pixels
    LOCAL hBmp              AS DWORD        'PB Graphic bitmap handle for image
    LOCAL hDC               AS DWORD        'Device context for PB Graphic bitmap
    LOCAL pGraphics         AS DWORD        'GDI+ Graphics object used to draw image
    LOCAL hStatus           AS LONG         'Status return value

    IF ISFALSE ISFILE(sImageFileName) THEN
        MessageBox(0, "[GraphicLoadImageFileToBitmap] Missing file: " & sImageFileName, "Error", 0)
        EXIT FUNCTION                                           'Exit if image not available
    END IF
    ucImageFileName = UCODE$(sImageFileName)                    'Gdip wants filename as unicode

    'Next ask GDI+ to read in the picture (ucImageFileName) to GDI+ image (pImage)
    hStatus = GdipLoadImagefromFile(STRPTR(ucImageFileName),pImage)
    IF hStatus THEN
        MessageBox(0, "[GraphicLoadImageFileToBitmap] [GdipLoadImagefromFile]" & $CRLF &"Read error on: " & sImageFileName, "Error", 0)
        EXIT FUNCTION                                           'Exit if GDI plus error on read
    END IF
    GdipGetImageDimension(pImage, ImgWidth, ImgHeight)          'Quiz GDI to get image size
    IF ImgWidth = 0 OR ImgHeight = 0 THEN EXIT FUNCTION         'Exit if bogus image size

    GRAPHIC BITMAP NEW ImgWidth, ImgHeight TO hBmp              'Make a correctly sized PB Bitmap
    GRAPHIC ATTACH hBmp, 0                                      'Select Bitmap as graphic target
    GRAPHIC GET DC TO hDC                                       'Get a device context for Bitmap

    GdipCreateFromHDC(hDC, pGraphics)                           'Create Graphic object
    IF pGraphics = 0 THEN
        GdipDisposeImage pImage
        GRAPHIC ATTACH hBmp, 0
        GRAPHIC BITMAP END
        EXIT FUNCTION
    END IF

    hStatus = GdipDrawImageRectI(pGraphics, pImage, 0, 0, ImgWidth, ImgHeight)

    IF pImage > 0 THEN GdipDisposeImage(pImage)                 'Cleanup
    IF pGraphics > 0 THEN GdipDeleteGraphics(pGraphics)         'more Cleanup

    IF hStatus = 0 THEN
        FUNCTION = hBmp                                         'If draw worked, return Bitmap
    ELSE
        GRAPHIC BITMAP END                                      'If draw failed, release Bitmap
    END IF

END FUNCTION    'GraphicLoadImageFileToBitmap

'===============================================================================

FUNCTION GraphicSaveBitmapToImageFile (BYVAL hBmp AS DWORD, sImageFileName AS STRING) AS LONG
'-------------------------------------------------------------------------------
' Supply the function with a PB Graphic memory bitmap containing an image,
' while specifying an ImageFileName - For instance photo.jpg - to write
' The extension of the filename selects image type:  .bmp | .png | .jpg | .gif | .tif
'
' This function is intended as the complement of GraphicLoadImageFileToBitmap.
' When you are finished using the PB memory bitmap, you must delete it with
' GRAPHIC BITMAP END.     (Steven Murray  3 February 2010  airborn.com.au)
'-------------------------------------------------------------------------------

'   hBmp                                    PB bitmap handle of image to be saved
'   sImageFileName                          Name image to be saved as, extn = type

    LOCAL ucImageFileName   AS STRING       'sImageFileName converted to unicode
    LOCAL Exten             AS STRING       'sImageFileName extension eg ".jpg"
    LOCAL FType             AS STRING       'sImageFileName mime-type eg "image-jpeg"
    LOCAL EncoderClsid      AS GUID         '16 byte GUID string of image encoder

    LOCAL bmpDat            AS STRING       'PB graphic bitmap saved to this string
    LOCAL ImgWidth          AS LONG         'Width  of the bitmap in pixels
    LOCAL ImgHeight         AS LONG         'Height of the bitmap in pixels
    LOCAL PixelPtr          AS DWORD        'Pointer the start of the pixel data

    LOCAL sbmi              AS Bitmapinfo   'Bitmapinfo Structure - dib header
    LOCAL pImage            AS DWORD        'GDI+ image pointer, after conversion
    LOCAL hStatus           AS LONG         'Status return value

    FUNCTION = %TRUE            '
    GRAPHIC ATTACH hBmp, 0                                      'Select Bitmap as "graphic target" to read out of
    GRAPHIC COLOR %BLACK,-2
    GRAPHIC PRINT "Xillus"
    GRAPHIC GET BITS TO bmpDat                                  'And get the image data into the string bmpDat

    ImgWidth = CVL(bmpDat,1) : ImgHeight = CVL(bmpDat,5)        'Get PB bitmap dimensions
    PixelPtr = STRPTR(bmpDat) + 8                               'First 8 bytes are width/height, then pixels

    sbmi.bmiHeader.biSize = SIZEOF(sbmi.bmiHeader)              'Length of the structure
    sbmi.bmiHeader.biWidth  = ImgWidth                          'Width of the bitmap
    sbmi.bmiHeader.biHeight = 0-ImgHeight                       'Height + sign is drawing direction
    sbmi.bmiHeader.biPlanes = 1
    sbmi.bmiHeader.biBitCount = 32                              'Each pixel in bitmap is 32 bits
    sbmi.bmiHeader.biCompression = %BI_RGB                      'Actually, PB says it is BGR, but this works

    'Next create a GDI+ bitmap (called pImage) from the bmi header we just made
    ' and the Pixel data supplied by "Graphic Get Bits" from the original bitmap
    hStatus = GdipCreateBitmapFromGdiDib(BYREF sbmi, BYVAL PixelPtr, pImage)
    IF hStatus THEN FUNCTION = %FALSE : EXIT FUNCTION           'Indicate failure and exit

    Exten = LCASE$(PATHNAME$(EXTN,sImageFileName)) : FType = "" 'Get extension
    'Now translate the file extension (eg ".png") to mimetype (eg "image/png")
    FType = SWITCH$(Exten=".png", "image/png", _
                    Exten=".jpg", "image/jpeg", _
                    Exten=".gif", "image/gif", _
                    Exten=".tif", "image/tiff", _
                    Exten=".bmp", "image/bmp")                  'Default seems to be bmp
    EncoderClsid = GUID$(GdiPlusGetEncoderClsid(FType))         'Get the CLSID of selected encoder
    ucImageFileName = UCODE$(sImageFileName & $NUL)             'Translate the filename to unicode

    'Next save the GDI+ bitmap (pImage) as an image of type specified by EncoderClsid
    ' to the filename specified when this function was called with no Encoder parameters
    hStatus = GdipSaveImageToFile(pImage, STRPTR(ucImageFileName), EncoderClsid, BYVAL %Null)

    IF hStatus THEN FUNCTION = %FALSE

    IF pImage THEN GdipDisposeImage(pImage)                     'Cleanup

END FUNCTION    'GraphicSaveBitmapToImageFile

'--------------------------------------------------------------------------------------------------

FUNCTION GdiPlusGetEncoderClsid (BYVAL strMimeType AS STRING) AS STRING
' Retrieve encoder's clsid, where strMimeType is ansi string e.g. "image/jpeg"
' Routine courtesy Jose Roca GdipUtils.inc, freeware, posted PB Forums  23/12/09
'
' The MIME types of the encoders built into GDI+ are as follows:
'   image/bmp   image/jpeg   image/gif   image/tiff   image/png

   LOCAL hr                 AS LONG
   LOCAL pImageCodecInfo    AS ImageCodecInfo PTR
   LOCAL numEncoders        AS DWORD
   LOCAL nSize              AS DWORD
   LOCAL i                  AS LONG
   LOCAL wstrlen            AS LONG
   LOCAL sMimeType          AS STRING

   hr = GdipGetImageEncodersSize(numEncoders, nSize)
   REDIM buffer(nSize - 1) AS BYTE
   pImageCodecInfo = VARPTR(buffer(0))
   hr = GdipGetImageEncoders(numEncoders, nSize, BYVAL pImageCodecInfo)
   IF hr = 0 THEN
      FOR i = 1 TO numEncoders
        wstrlen = lstrlenW(BYVAL @pImageCodecInfo.MimeType)
        IF wstrlen THEN sMimeType = ACODE$(PEEK$(@pImageCodecInfo.MimeType, wstrlen * 2))
         IF INSTR(UCASE$(sMimeType), UCASE$(strMimeType) ) THEN
            FUNCTION = GUIDTXT$(@pImageCodecInfo.ClassID)
            EXIT FOR
         END IF
         INCR pImageCodecInfo                               '// Increments pointer
      NEXT
   END IF

END FUNCTION 'GdiPlusGetEncoderClsid

'-------------------------------------------------------------------------------
' The following routines are based on: Source code forum, Don Schullian,  Sep 29th, 2005, 01:18 AM:
' his reference:
'          special thanks go to the following (and some i've most likely missed) for
'          general gdi+   patrice terrier
'          resource code  ryan cross
'          debugging      aslan babakhanov

FUNCTION GdipLoadResourceToBitmap(BYVAL sResourceName AS STRING) AS DWORD
' The resource image has to be compiled as RCDATA from any of these formats: .bmp | .png | .jpg | .gif | .tif
' The resource must be embedded in the current .exe file

    LOCAL pImage            AS DWORD        'GDI+ image pointer, after reading in
    LOCAL ImgWidth          AS SINGLE       'Image width, pixels
    LOCAL ImgHeight         AS SINGLE       'Image height, pixels
    LOCAL hBmp              AS DWORD        'PB Graphic bitmap handle for image
    LOCAL hDC               AS DWORD        'Device context for PB Graphic bitmap
    LOCAL pGraphics         AS DWORD        'GDI+ Graphics object used to draw image
    LOCAL hStatus           AS LONG         'Status return value

    pImage = LoadImageFromResource(sResourceName)
    IF pImage = 0 THEN
        MessageBox(0, "[GdipLoadResourceToBitmap] [LoadImageFromResource]" & $CRLF & "Resource read error: " & sResourceName, "Error", 0)
        EXIT FUNCTION
    END IF

    GdipGetImageDimension(pImage, ImgWidth, ImgHeight)          'Quiz GDI to get image size
    IF ImgWidth = 0 OR ImgHeight = 0 THEN EXIT FUNCTION         'Exit if bogus image size

    GRAPHIC BITMAP NEW ImgWidth, ImgHeight TO hBmp
    GRAPHIC ATTACH hBmp, 0
    GRAPHIC GET DC TO hDC

    GdipCreateFromHDC(hDC, pGraphics)

    IF pGraphics = 0 THEN
        GdipDisposeImage pImage
        GRAPHIC ATTACH hBmp, 0
        GRAPHIC BITMAP END
        EXIT FUNCTION
    END IF

    hStatus = GdipDrawImageRectI(pGraphics, pImage, 0, 0, ImgWidth, ImgHeight)

    IF pImage > 0 THEN GdipDisposeImage(pImage)
    IF pGraphics > 0 THEN GdipDeleteGraphics(pGraphics)

    IF hStatus = 0 THEN
        FUNCTION = hBmp
    ELSE
        GRAPHIC BITMAP END
    END IF

END FUNCTION 'GdipLoadResourceToBitmap

'-----------------------------------------------------------------
'
FUNCTION LoadImageFromResource (BYVAL sResourceName AS STRING) AS DWORD

    LOCAL hResource           AS DWORD
    LOCAL imageSize           AS DWORD
    LOCAL pResourceData       AS DWORD
    LOCAL m_hBuffer           AS DWORD
    LOCAL pBuffer             AS DWORD
    LOCAL pStream             AS DWORD PTR
    LOCAL m_pBitmap           AS DWORD
    LOCAL m_pBitmap_Status    AS LONG
    LOCAL pName               AS ASCIIZ * %max_path

    pName = sResourceName

    ' The value of hInst (first parameter) can be left as zero, if the resource data is in the current program.
    hResource = FindResource(0, pName, BYVAL %rt_rcdata)
    IF hResource = 0 THEN EXIT FUNCTION

    imageSize = SizeOfResource(0, hResource)
    IF imageSize = 0 THEN EXIT FUNCTION

    pResourceData = LockResource(LoadResource(0, hResource))
    IF pResourceData = 0 THEN EXIT FUNCTION

    m_hBuffer = GlobalAlloc(%gmem_moveable, imageSize)
    IF m_hBuffer = 0 THEN EXIT FUNCTION

    pBuffer = GlobalLock(m_hBuffer)
    IF pBuffer = 0 THEN
        GlobalFree m_hBuffer
        EXIT FUNCTION
    END IF

    CopyMemory(pBuffer, pResourceData, imageSize)
    IF CreateStreamOnHGlobal(m_hBuffer, %false, pStream) <> 0 THEN
        GlobalUnlock m_hBuffer
        EXIT FUNCTION
    END IF

    m_pBitmap_Status = GdipCreateBitmapFromStream(pStream, m_pBitmap)
    CALL DWORD @@pStream[2] USING pStreamRelease(pStream)

    IF (m_pBitmap <> 0)  AND (m_pBitmap_Status = 0) THEN
        FUNCTION = m_pBitmap                                    ' Success - in all other cases 0 is returned
    END IF

END FUNCTION 'LoadImageFromResource

'------------------------------------------------------------------------------
